<?php
/**
 * This is core configuration file.
 *
 * Use it to configure core behaviour ofCake.
 *
 * PHP versions 4 and 5
 *
 * CakePHP :  Rapid Development Framework <http://www.cakephp.org/>
 * Copyright (c)	2009, Cake Software Foundation, Inc.
 *								1785 E. Sahara Avenue, Suite 490-204
 *								Las Vegas, Nevada 89104
 *
 * Licensed under The MIT License
 * Redistributions of files must retain the above copyright notice.
 */
/**
 * Database configuration class.
 * You can specify multiple configurations for production, development and testing.
 *
 * driver =>
 * mysql, postgres, sqlite, adodb, pear-drivername
 *
 * connect =>
 * MySQL set the connect to either mysql_pconnect of mysql_connect
 * PostgreSQL set the connect to either pg_pconnect of pg_connect
 * SQLite set the connect to sqlite_popen  sqlite_open
 * ADOdb set the connect to one of these
 *	(http://phplens.com/adodb/supported.databases.html) and
 *	append it '|p' for persistent connection. (mssql|p for example, or just mssql for not persistent)
 *
 * host =>
 * the host you connect to the database
 * MySQL 'localhost' to add a port number use 'localhost:port#'
 * PostgreSQL 'localhost' to add a port number use 'localhost port=5432'
 *
 */
class DATABASE_CONFIG
{
	var $default = array('driver' => 'adodb',
								'connect' => 'mysqli',
								'host' => '127.0.0.1',
								'login' => 'root',
								'password' => '',
								'database' => 'nolapro',
								'prefix' => '');

	var $test = array('driver' => 'adodb',
								'connect' => 'mysqli',
								'host' => '127.0.0.1',
								'login' => 'root',
								'password' => '',
								'database' => 'nolapro',
								'prefix' => '');

	var $nolapro_dir = "../../../";  // Path to the NolaPro files; not necessary to fill this in
							
	function __construct() {
		// Select the correct DB if we are in a multi-DB environment
		include_once(dirname(__FILE__)."/multidb.php");
	}
}
?>